# generated by datamodel-codegen:
#   filename:  application_env_config.openapi.json
#   timestamp: 2025-05-27T16:44:35+00:00

from __future__ import annotations
from typing import Any, Dict, List, Optional, Union
from pydantic import BaseModel, ConfigDict, Field, RootModel, conint
from enum import Enum


class AccessPoint(BaseModel):
    public_ip: Optional[str] = None
    public_port: Optional[conint(ge=0)] = None
    same_node: bool
    vpn_ip: str
    vpn_port: conint(ge=0)


class ApplicationInfo(BaseModel):
    application_id: str
    application_name: str
    deployed_application_id: str
    deployed_application_name: str
    git_branch: Optional[str] = None
    git_url: Optional[str] = None
    is_release_version: bool
    system_id: str


class ClientServiceConfig(BaseModel):
    model_config = ConfigDict(
        extra="allow",
    )
    interface_name: Optional[str] = None
    key: str
    name: str
    protocol: Optional[str] = None
    spec: str


class GpioLineInfo(BaseModel):
    active_state: str
    consumer: Optional[str] = None
    direction: str
    line_offset: conint(ge=0)
    name: Optional[str] = None
    used: bool


class I2cDetectedDevice(BaseModel):
    address: str
    description: Optional[str] = None


class PeripheralType1(Enum):
    Camera = "Camera"


class PeripheralType2(Enum):
    RealSense = "RealSense"


class PeripheralType3(Enum):
    Speaker = "Speaker"


class PeripheralType4(Enum):
    Keyboard = "Keyboard"


class PeripheralType5(Enum):
    Mouse = "Mouse"


class PeripheralType6(Enum):
    Microphone = "Microphone"


class PeripheralType7(Enum):
    GPU = "GPU"


class PeripheralType8(Enum):
    I2C = "I2C"


class PeripheralType9(Enum):
    GPIO = "GPIO"


class PeripheralType10(Enum):
    ISP = "ISP"


class PeripheralType11(Enum):
    Codec = "Codec"


class PeripheralType12(Enum):
    Rendering = "Rendering"


class PeripheralType13(Enum):
    GenericDevice = "GenericDevice"


class PeripheralType14(BaseModel):
    Other: str


class PeripheralType(
    RootModel[
        Union[
            PeripheralType1,
            PeripheralType2,
            PeripheralType3,
            PeripheralType4,
            PeripheralType5,
            PeripheralType6,
            PeripheralType7,
            PeripheralType8,
            PeripheralType9,
            PeripheralType10,
            PeripheralType11,
            PeripheralType12,
            PeripheralType13,
            PeripheralType14,
        ]
    ]
):
    root: Union[
        PeripheralType1,
        PeripheralType2,
        PeripheralType3,
        PeripheralType4,
        PeripheralType5,
        PeripheralType6,
        PeripheralType7,
        PeripheralType8,
        PeripheralType9,
        PeripheralType10,
        PeripheralType11,
        PeripheralType12,
        PeripheralType13,
        PeripheralType14,
    ]


class ProviderEndpointConfig(BaseModel):
    model_config = ConfigDict(
        extra="allow",
    )
    encoding: Optional[str] = None
    endpoint_key: str
    endpoint_name: str
    interface_name: Optional[str] = None
    protocol: Optional[str] = None
    provider_message_type: str
    requester_message_type: str


class PublisherTopicConfig(BaseModel):
    model_config = ConfigDict(
        extra="allow",
    )
    encoding: Optional[str] = None
    interface_name: Optional[str] = None
    message_type: str
    protocol: Optional[str] = None
    topic_key: str
    topic_name: str


class RealSenseCameraPeripheral(BaseModel):
    device_nodes: List[str]
    model: str
    name: str
    peripheral_type: PeripheralType
    serial_number: str


class RenderingPeripheral(BaseModel):
    device_nodes: List[str]
    max_performance: Optional[conint(ge=0)] = None
    name: str
    peripheral_type: PeripheralType
    supported_apis: List[str]


class RequesterEndpointConfig(BaseModel):
    model_config = ConfigDict(
        extra="allow",
    )
    encoding: Optional[str] = None
    endpoint_key: str
    endpoint_name: str
    interface_name: Optional[str] = None
    protocol: Optional[str] = None
    provider_message_type: str
    requester_message_type: str


class ServerServiceConfig(BaseModel):
    model_config = ConfigDict(
        extra="allow",
    )
    interface_name: Optional[str] = None
    key: str
    name: str
    protocol: Optional[str] = None
    spec: str


class StorageConfig(BaseModel):
    access_key: str
    endpoint_url: str
    secret_key: str
    url: str


class SubscriberTopicConfig(BaseModel):
    model_config = ConfigDict(
        extra="allow",
    )
    encoding: Optional[str] = None
    interface_name: Optional[str] = None
    message_type: str
    protocol: Optional[str] = None
    topic_key: str
    topic_name: str


class BoundClient(AccessPoint, ClientServiceConfig):
    pass


class BoundRequester(AccessPoint, RequesterEndpointConfig):
    pass


class BoundSubscriber(AccessPoint, SubscriberTopicConfig):
    pass


class CameraPeripheral(BaseModel):
    camera_type: Optional[str] = None
    device_nodes: List[str]
    name: str
    peripheral_type: PeripheralType
    protocol: Optional[str] = None
    reference: str
    volumes: List[List]


class CodecPeripheral(BaseModel):
    device_nodes: List[str]
    name: str
    peripheral_type: PeripheralType
    supported_codecs: List[str]


class GenericDevicePeripheral(BaseModel):
    device_node: str
    name: str
    peripheral_type: PeripheralType


class GpioPeripheral(BaseModel):
    chip_name: str
    device_nodes: List[str]
    label: str
    lines: List[GpioLineInfo]
    num_lines: conint(ge=0)
    peripheral_type: PeripheralType


class GpuPeripheral(BaseModel):
    device_nodes: List[str]
    index: Optional[conint(ge=0)] = None
    model: str
    name: str
    peripheral_type: PeripheralType
    vram: Optional[conint(ge=0)] = None


class I2cPeripheral(BaseModel):
    bus_number: conint(ge=0)
    detected_devices: List[I2cDetectedDevice]
    device_nodes: List[str]
    name: str
    peripheral_type: PeripheralType


class InterfaceConfig(BaseModel):
    clients: Dict[str, BoundClient]
    name: str
    providers: Dict[str, ProviderEndpointConfig]
    publishers: Dict[str, PublisherTopicConfig]
    requesters: Dict[str, BoundRequester]
    servers: Dict[str, ServerServiceConfig]
    subscribers: Dict[str, BoundSubscriber]


class IspPeripheral(BaseModel):
    device_nodes: List[str]
    name: str
    peripheral_type: PeripheralType
    supported_features: List[str]


class OtherPeripheral(BaseModel):
    device_nodes: List[str]
    name: str
    peripheral_type: PeripheralType
    reference: str


class Peripheral1(BaseModel):
    GPU: GpuPeripheral


class Peripheral2(BaseModel):
    I2C: I2cPeripheral


class Peripheral3(BaseModel):
    GPIO: GpioPeripheral


class Peripheral4(BaseModel):
    Camera: CameraPeripheral


class Peripheral5(BaseModel):
    RealSense: RealSenseCameraPeripheral


class Peripheral6(BaseModel):
    ISP: IspPeripheral


class Peripheral7(BaseModel):
    Codec: CodecPeripheral


class Peripheral8(BaseModel):
    Rendering: RenderingPeripheral


class Peripheral9(BaseModel):
    Speaker: OtherPeripheral


class Peripheral10(BaseModel):
    Keyboard: OtherPeripheral


class Peripheral11(BaseModel):
    Mouse: OtherPeripheral


class Peripheral12(BaseModel):
    GenericDevice: GenericDevicePeripheral


class Peripheral13(BaseModel):
    Other: OtherPeripheral


class Peripheral(
    RootModel[
        Union[
            Peripheral1,
            Peripheral2,
            Peripheral3,
            Peripheral4,
            Peripheral5,
            Peripheral6,
            Peripheral7,
            Peripheral8,
            Peripheral9,
            Peripheral10,
            Peripheral11,
            Peripheral12,
            Peripheral13,
        ]
    ]
):
    root: Union[
        Peripheral1,
        Peripheral2,
        Peripheral3,
        Peripheral4,
        Peripheral5,
        Peripheral6,
        Peripheral7,
        Peripheral8,
        Peripheral9,
        Peripheral10,
        Peripheral11,
        Peripheral12,
        Peripheral13,
    ]


class MountedPeripheral(BaseModel):
    name: str = Field(
        ...,
        description="The name of the peripheral. That is used by the application version to identify the peripheral",
    )
    peripheral: Peripheral


class MountedPeripherals(BaseModel):
    peripherals: List[MountedPeripheral]


class ApplicationEnvConfig(BaseModel):
    application_info: ApplicationInfo
    config: Any
    interfaces: Dict[str, InterfaceConfig]
    peripherals: MountedPeripherals
    storage: Optional[StorageConfig] = None
